/*
 * %Copyright%
 */

#include <RTPriv/ResrcMgr.h>
#include <RTPubl/Control.h>

void RTController_freeMsg( RTController * this, RTMessage * msg )
{
#if PURIFY
    (void)this; /* it _is_ used */
    delete_RTMessage( msg );
#else
    RTMessage_clear( msg );

    msg->Next      = this->freeList;
    this->freeList = msg;

    if( ++this->freeListSize > this->_numInternalMsgs )
    {
	int numMsgs = this->freeListSize - MINIMUM_FREE_MSGQ_SIZE;

	RTResourceMgr_msgFree( &this->freeList, (RTMessageIndex)numMsgs );

	this->freeListSize = MINIMUM_FREE_MSGQ_SIZE;
    }
#endif
}
